clear variables;close all;clc

tic % start timer

prompting_method = 3;

% if 0, then display the prompt only, without running the API
% if 1, then use gpt-3.5
% if 2, then use gpt-4-0314
% if 3, then use gpt-4-0613
% if 4, then use bootstrapping with 320 repetitions and different temperature levels (Questions 36–38 of Exam 2) (gpt-4-0314)
% if 5, then use bootstrapping with 50 repetitions at a temperature level of 1 (each of the three exams)

row=0;

for exam = 1:3 % loop across exams
    disp(['EXAM NUMBER: ' num2str(exam)])

    if exam==1
        file_text_booklet='Exam material\Period 1\VW-1002-a-22-1-b.pdf'; % file name of the text booklet
        file_text_exam   ='Exam material\Period 1\VW-1002-a-22-1-o.pdf'; % file name of the exam questions
    elseif exam==2
        file_text_booklet='Exam material\Period 2\VW-1002-a-22-2-b.pdf'; % file name of the text booklet
        file_text_exam   ='Exam material\Period 2\VW-1002-a-22-2-o.pdf'; % file name of the exam questions
    elseif exam==3
        file_text_booklet='Exam material\Period 3\VW-1002-a-22-3-b.pdf'; % file name of the text booklet
        file_text_exam   ='Exam material\Period 3\VW-1002-a-22-3-o.pdf'; % file name of the exam questions
    end
    
    %% Read the texts of the text booklet
    text_booklet = extractFileText(file_text_booklet,'extractionmethod','article');
    text_booklet = char(text_booklet);
    text_booklet = strrep(text_booklet,newline,' ');
    
    clear booklet_texts
    
    index_of_new_text=NaN(20,1);
    for text_count=1:length(index_of_new_text)
        idx_new_text=strfind(text_booklet,['Tekst ' num2str(text_count) ' ']);
        if ~isempty(idx_new_text)
            index_of_new_text(text_count)=strfind(text_booklet,['Tekst ' num2str(text_count) ' ']); % Search for the string "Tekst 1 ", "Tekst 2 ", etc.
        end
    end
    index_of_new_text(isnan(index_of_new_text))=[];
    
    for text_count = 1:length(index_of_new_text) % loop over the texts in the booklet
        start_index = index_of_new_text(text_count);
        if text_count==length(index_of_new_text) % if last text
            end_index=strfind(text_booklet,' einde ')-1;
        else
            end_index=index_of_new_text(text_count+1)-1;
        end
        booklet_texts{text_count} = text_booklet(start_index:end_index); % Store the texts in a Cell
    end
    
    %% Read the exam questions
    file_text_exam = extractFileText(file_text_exam,'extractionmethod','article');
    file_text_exam = char(file_text_exam);
    file_text_exam = strrep(file_text_exam,newline,' ');
    
    clear exam_questions
    
    index_of_new_text=NaN(20,1);
    for text_count=1:length(index_of_new_text)
        idx_new_text=strfind(file_text_exam,['Tekst ' num2str(text_count) ' ']);
        if ~isempty(idx_new_text)
            index_of_new_text(text_count)=strfind(file_text_exam,['Tekst ' num2str(text_count) ' ']); % Search for the string "Tekst 1 ", "Tekst 2 ", etc.
        end
    end
    
    index_of_new_text(isnan(index_of_new_text))=[];
    
    for text_count = 1:length(index_of_new_text) % loop over the texts of the exam
        start_index=index_of_new_text(text_count);
        if text_count==length(index_of_new_text) % if last text
            end_index=strfind(file_text_exam,' einde ')-1;
        else
            end_index=index_of_new_text(text_count+1)-1;
        end
        exam_questions{text_count}=file_text_exam(start_index:end_index); % Store the texts in a Cell
    end
    
    %% Loop over the texts and send prompt to API
    
    import matlab.net.* matlab.net.http.* matlab.net.http.io.*
    
    header = [HeaderField('Content-Type', 'application/json');HeaderField('Authorization', 'Bearer sk-secret key')]';
    uri = URI('https://api.openai.com/v1/chat/completions');
    
    for text_count=1:length(index_of_new_text) % loop over the texts of the text booklet
        prompt=['Answer all questions, including multiple-choice questions. Only provide the question number and the answer, nothing else:'...
            newline 'TEXT: ' newline booklet_texts{text_count} newline 'QUESTIONS: ' newline exam_questions{text_count}];
        if prompting_method==0
            disp(newline)
            disp(newline)
            disp(['Exam number: ' num2str(exam) ', Text number: ' num2str(text_count)])
            disp(newline)
            disp(prompt)
        elseif prompting_method==1
            n=1;body = JSONProvider(struct('model', 'gpt-3.5-turbo-0301','temperature',0,'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
            response = RequestMessage('post', header, body).send(uri.EncodedURI);
            disp(response.Body.Data.choices.message.content); % display API responses to the exam questions for text booklet 'text_count'
        elseif prompting_method==2
            n=1;body = JSONProvider(struct('model', 'gpt-4-0314','temperature',0,'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
            response = RequestMessage('post', header, body).send(uri.EncodedURI);
            disp(response.Body.Data.choices.message.content); % display API responses to the exam questions for text booklet 'text_count'
        elseif prompting_method==3
            n=1;body = JSONProvider(struct('model', 'gpt-4-0613','temperature',0,'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
            response = RequestMessage('post', header, body).send(uri.EncodedURI);
            disp(response.Body.Data.choices.message.content); % display API responses to the exam questions for text booklet 'text_count'
        elseif  prompting_method==4
            if exam==2 && text_count==10
                TEMPERATURES=0:0.1:2;
                for t=1:length(TEMPERATURES)
                    rep=1;
                    while rep<=16 % loop over batches
                        disp([t rep])
                        try
                            n=20;
                            body = JSONProvider(struct('model', 'gpt-4-0314','temperature',TEMPERATURES(t),'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
                            response = RequestMessage('post', header, body).send(uri.EncodedURI);
                            for i=1:n
                                StoreResponses{t,(rep-1)*n+i}=response.Body.Data.choices(i).message.content; % use this for
                                disp(response.Body.Data.choices(i).message.content)
                            end
                            rep=rep+1;
                        catch error
                            pause(5)
                        end
                    end % end of rep loop
                    save('StoreResponses_temperature_320reps.mat','StoreResponses')
                end % end of temperature loop
            end % end of Question selection
        elseif prompting_method==5
            rep=1;
            row=row+1;
            while rep<=5 % loop over batches
                disp([row rep])
                try
                    n=10;
%                    body = JSONProvider(struct('model', 'gpt-4-0314','temperature',1,'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
                    body = JSONProvider(struct('model', 'gpt-4-0613','temperature',1,'n',n,'messages', {{struct('role', 'user','content', prompt')}}));
                    response = RequestMessage('post', header, body).send(uri.EncodedURI);
                    for i=1:n
                        StoreResponses{row,(rep-1)*n+i}=response.Body.Data.choices(i).message.content;
                        disp(response.Body.Data.choices(i).message.content)
                    end
                    rep=rep+1;
                catch error
                    pause(5)
                end
            end % end of rep loop
            save('StoreResponses.mat','StoreResponses')
        end
    end % loop over texts
end % end of loop over exams
disp(newline)
disp(newline)
toc % display elapsed time
